#ifndef P4FS_FILEWRITER_ASYNC_H
#define P4FS_FILEWRITER_ASYNC_H

#include "filewriter.h"
#include <list>

class FileWriterASync : public FileWriter
{
public:
	static FileWriterASync*		GetFileWriter(const std::string& inName, long long inFileSize);
	static void					Finalize();

								~FileWriterASync();
								
	virtual bool				Open(bool inWriteable, int inModTime);
	virtual bool				Close();

	virtual void				GetWriteBuffer(unsigned char*& outBuf, int& outLength);
	virtual bool				ReleaseWriteBuffer(int inRemainingLength);

	virtual void				Finish();
	virtual bool				IsFinished();
	virtual void				HandleAbort();

	virtual bool				ChModTime(int inModTime);
	
private :
	struct BufInfo
	{
								BufInfo(FileWriterASync* inFileWriter);
								~BufInfo();

		unsigned char*			mData;
		int						mLength;
		int						mSize;
		OVERLAPPED				mOverlappedInfo;
	};

								FileWriterASync(const std::string& inName, long long inFileSize);

	int							Flush(bool inWriteAll);
	void						Wait(int inMSecs);

	HANDLE						mHandle;
	std::list<BufInfo*>			mBuffers;
	long long					mWriteOffset;
	
	static int					mSectorSize;
};

#endif