#ifndef FS_CLIENT_H
#define FS_CLIENT_H

#include <string>

class FsClientUser : public ClientUser
{
public:
								FsClientUser();

	virtual FileSys*			File(FileSysType type);
	virtual void				OutputStat(StrDict *varList);
	
	virtual void				HandleError(Error *e);
	std::string					GetErrorMessage()		{ return mErrorMessage; }

	void						SetSyncStatCallback(SyncStatCallbackFunc inSyncStatCallback);
	void						SetFileStatCallback(FileStatCallbackFunc inFileStatCallback);
	void						SetClobberCallback(ClobberCallbackFunc inClobberCallback);
	
private:
	SyncStatCallbackFunc		mSyncStatCallBack;
	FileStatCallbackFunc		mFileStatCallback;
	ClobberCallbackFunc			mClobberCallback;

	std::string					mErrorMessage;
};

#endif